
/* This file is part of MySQLConnectus by Sergio Decherchi

Copyright (C) 2004 Sergio Decherchi

This program is free software; you can redistribute it 
and/or modify it under the terms of the GNU General Public License 
as published by the Free Software Foundation; either version 2 of 
the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, 
but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
GNU General Public License for more details (gpl.txt).
You should have received a copy of the GNU General Public License 
along with this program; if not, write to the Free Software Foundation, 
Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA */

import javax.swing.border.*;
import javax.swing.*;
import javax.swing.table.*;
import javax.swing.event.*;
import javax.swing.filechooser.FileFilter;
import javax.swing.filechooser.FileView;
import java.awt.*;
import java.awt.event.*;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.print.PageFormat;
import java.awt.print.Printable;
import java.awt.print.PrinterJob;
import java.awt.print.PrinterException;
import java.io.*;
import java.util.*;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.sql.Statement;
import java.sql.*;

/**A table inserted in a JInternalFrame */
public class Table extends javax.swing.JInternalFrame implements Printable  
{

	private		ResultSet			rs;
	protected	int					recordCount;
	private		javax.swing.JTable	Data;
	private		boolean				firstTime	=true;
	private		int					offset		=90;
	private		int					numPages	=0;
	private		int					selectedPage=0;
	private		int 				cc			=0;
	private		PageFormat			page		=null;
	private		PrinterJob			printer		=null;
	private		OrderedData			orderedData;
	private		boolean				isSaved		=false;				
	private		Vector				currentSavedDoc;			
	private		Vector				columnNames;
	public 		boolean 			internalClosed=false;
	
    /**Cunstructor used for builidng a table by a ResultSet */
    public Table(ResultSet rs1,JDesktopPane jdp) {
        
//the same as TextEditFrame
	
	rs=rs1;
    initComponents();
    isSaved=false;
    final Table mytable=this;
    printer = PrinterJob.getPrinterJob();
   	page = printer.defaultPage();
    setTitle("Results");
    setLocation(200,0);
    this.setClosable(true);
	this.setMaximizable(true);
	this.setIconifiable(true);
	this.setResizable(true);
	this.addInternalFrameListener(new InternalFrameAdapter() 
	{
		public void internalFrameClosing(InternalFrameEvent e) 
		{
		internalClosed=true;
		//System.out.println(internalClosed);
		} 
	}
	);
	
	JPanel panel = new JPanel();
	JButton print=new JButton("Print",new ImageIcon("Resources/print.gif"));
	JButton save=new JButton("Save",new ImageIcon ("Resources/save.gif"));
	panel.add(print);
	panel.add(save);
	getContentPane().add(panel,BorderLayout.SOUTH);
	jdp.add(this,1);
	print.addActionListener( new ActionListener ()
	{
	public void actionPerformed (ActionEvent evt)
	{
		printer.setPrintable(mytable,page);
		orderedData = new OrderedData();
		int numPages=orderedData.reorderForPrintingOrStreaming(rs,65,Data.getColumnCount());	
		selectedPage=0;
		try {
               for (int p=0;p<numPages;p++)
               {
               	printer.print();
               	selectedPage++;
               }
            }
            catch ( PrinterException pe ) 
            {
				JOptionPane.showMessageDialog(null,"No printing device available!","Info",2);																											
            	pe.printStackTrace();
            }
        
	} 
	
	});
	save.addActionListener( new ActionListener () 
	{
	public void actionPerformed (ActionEvent evt)
	{
		
		String tableName="";
		String tablePath="";
		
		try
		{
		
		JFileChooser chooser=new JFileChooser();
		chooser.setCurrentDirectory(new File("."));
		chooser.addChoosableFileFilter(new TabFilter());
		chooser.setFileView(new FileIconViewForTab(new TabFilter(),new ImageIcon("Resources/JTable.gif")));
											
		int r =chooser.showSaveDialog(null);
		
		if (r==JFileChooser.APPROVE_OPTION)
			{
			tablePath = chooser.getSelectedFile().getAbsolutePath();
			tableName = chooser.getSelectedFile().getName();
			if (!tablePath.endsWith(".dat"))
			{
			tableName=tableName.concat(".dat");
			tablePath=tablePath.concat(".dat");
			}
			
		
	
		FileOutputStream fos = new FileOutputStream(tablePath);
 		ObjectOutputStream oos = new ObjectOutputStream(fos);
		PermanentResultSet prs = new PermanentResultSet(rs,oos);
		//System.out.println(tableName);
		}
		
		if (r==JFileChooser.APPROVE_OPTION)
		JOptionPane.showMessageDialog(null,"File saved as "+tableName,"Info",1);
		
		}
		
		catch (FileNotFoundException fnfe)
		{
		JOptionPane.showMessageDialog(null,"Error file not found!","Info",2);																											
		}
		catch (IOException ioe) 
		{
		JOptionPane.showMessageDialog(null,"IO Error!","Info",0);																											
		}
		
	}
	
	});						
	
	this.show();											
	
    }
    
    /**Cunstructor used for builidng a table by a saved table file */
    public Table(Vector savedDocx,Vector columnNames,JDesktopPane jdp,String windowTitle)
    {
    isSaved=true;
    final Table mytable=this;
    final Vector savedDoc=savedDocx;
    this.columnNames=columnNames;
   	
    currentSavedDoc=savedDocx;
    final Vector currentColumnNames=columnNames;
    
    printer = PrinterJob.getPrinterJob();
   	page = printer.defaultPage();
        							 
    setTitle(windowTitle);
    setLocation(100,30);
    this.setClosable(true);
	this.setMaximizable(true);
	this.setIconifiable(true);
	this.setResizable(true);
	
	JPanel panel = new JPanel();
	JButton print=new JButton("Print",new ImageIcon("Resources/print.gif"));
	JButton save=new JButton("Save",new ImageIcon ("Resources/save.gif"));
	panel.add(print);
	panel.add(save);
	getContentPane().add(panel,BorderLayout.SOUTH);
	jdp.add(this,1);
	print.addActionListener( new ActionListener ()
	{
	public void actionPerformed (ActionEvent evt)
	{
		printer.setPrintable(mytable,page);
		orderedData = new OrderedData();
		int numPages=savedDoc.size();	
		orderedData.doc=savedDoc;
		selectedPage=0;
		try {
        	for (int p=0;p<numPages;p++)
            	{
                	printer.print();
                	selectedPage++;
                }
            }
        catch ( PrinterException pe ) 
        {
			JOptionPane.showMessageDialog(null,"No printing device available!","Info",2);																											
			pe.printStackTrace();
        }
        
	} 
	
	});
	save.addActionListener( new ActionListener () 
	{
	public void actionPerformed (ActionEvent evt)
	{
		
		String tableName="";
		String tablePath="";
		
		JFileChooser chooser=new JFileChooser();
		chooser.setCurrentDirectory(new File("."));
		chooser.addChoosableFileFilter(new TabFilter());
		chooser.setFileView(new FileIconViewForTab(new TabFilter(),new ImageIcon("Resources/JTable.gif")));
											
		int r =chooser.showSaveDialog(null);
		if (r==JFileChooser.APPROVE_OPTION)
		{
			tablePath = chooser.getSelectedFile().getAbsolutePath();
			tableName = chooser.getSelectedFile().getName();
		try
		{
		//System.out.println(tableName);
		
		if (!tablePath.endsWith(".dat"))
			{
			tableName=tableName.concat(".dat");
			tablePath=tablePath.concat(".dat");
			}
			
		
		FileOutputStream fos = new FileOutputStream(tablePath);
 		ObjectOutputStream oos = new ObjectOutputStream(fos);
		PermanentResultSet prs= new PermanentResultSet(oos,savedDoc,currentColumnNames,currentColumnNames.size(),savedDoc.size());
		
		
		JOptionPane.showMessageDialog(null,"File saved as "+tableName,"Info",1);
		
		}
		catch (FileNotFoundException fnfe)
		{
		JOptionPane.showMessageDialog(null,"Error file not found!","Info",2);																											
		}
		catch (IOException ioe) 
		{
		JOptionPane.showMessageDialog(null,"IO Error!","Info",0);																											
		}
		}
		
		
	}
	
	});						
	
	this.show();											
	
      
        initComponentsForSavedTable();
    	
    
    }
    /**Necessary method for printable interface*/
    public int print( Graphics g, PageFormat pf, int pageIndex ) {
            

            
	int printMode=0;
	int lastPage=0;   
	int posX=10;
	int posY=10;
	int cc=Data.getColumnCount();
           //System.out.println(pageIndex+"$"+printMode);		
                
    Graphics2D g2= (Graphics2D)g;
            
    if ( pageIndex == 0 ) {
       lastPage = Integer.MAX_VALUE;
            }
            if ( printMode == 0 )  {
           		if ( pageIndex > 0 )
          		{
          	//System.out.println(pageIndex);		
                  return NO_SUCH_PAGE;
          
          		}
            }
            else{
                	if ( pageIndex > lastPage )
            		{
           // System.out.println("NO");	
                  return NO_SUCH_PAGE;
            		}
            	}
				
            g2.setFont( new Font("Monotype Corsiva",Font.ITALIC,8) );
           	g2.translate( (int) pf.getImageableX(), (int) pf.getImageableY());
            g2.drawString("Printed with MySQLConnectus 0.3 by SedekFX" , posX, posY );
            
            posY=posY+10;
            
            g2.drawString("",posX,posY);
            g2.setFont( new Font("Verdana",Font.BOLD,9) );
            g2.setColor( Color.black );
   			
   		
        
        
        if (firstTime)
        {
      
        Object[] options = { "70d","90d", "110d","130d","150d","170d","190d" };
		offset=JOptionPane.showOptionDialog(null, "Choose the size of columns on your page\nIf you press X default value 90 will be applied", "Columns size", 
		JOptionPane.DEFAULT_OPTION, JOptionPane.QUESTION_MESSAGE,
		null, options, options[0]);
		firstTime=false;
        
        
		if (offset==0)
		{
			offset=70;
		}
		else if (offset==1)
		{
			offset=90;
		}
		else if (offset==2)
		{
			offset=110;
		}
		else if (offset==3)
		{
			offset=130;
		}
		else if (offset==4)
		{
			offset=150;
		}
		else if (offset==5)
		{
			offset=170;
		}
		else if (offset==6)
		{
			offset=190;
		}
		
		else
			offset=90;
		}
		
		//System.out.println(cc);
    	//System.out.println(rc);        
    
		
        for (int m=0;m<cc;m++)
        	{
        		g2.drawString((Data.getColumnName(m))+"     ",posX,posY);
        		//System.out.println((Data.getColumnName(m)));
        		posX=posX+offset;
        	}   
    	
        g2.setFont( new Font("Verdana",0,9) );
        posY=posY+10;
        posX=10;
       	
       	int numberOfLines=(((Vector)(orderedData.doc).get(selectedPage)).size());
        
        //System.out.println(numberOfLines);
        for (int i=0;i<numberOfLines;i++)
        	{
        	posX=10;	
        		for (int j=0;j<cc;j++)
        		{
        		
        		//System.out.println((String)(((Vector)(((Vector)(orderedData.doc).get(selectedPage)).get(i))).get(j)));
        		g2.drawString((String)(((Vector)(((Vector)(orderedData.doc).get(selectedPage)).get(i))).get(j)),posX,posY);	
            	
            	posX=posX+offset;    
   		
        		
        	
        		}
        	//System.out.println(i);	
        	posY=posY+10;
        	
        	
        	
        	}
        	
   		return PAGE_EXISTS;

            
            
			        }
    /**Initialize components for tables generated by a ResultSet */
    private void initComponents() {
     
        Data = new javax.swing.JTable();
		Data.setModel(getModel());
        Data.setGridColor(Color.BLUE);
        Data.doLayout();
        Data.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
        JScrollPane scrollpane = new JScrollPane(Data);
        scrollpane.setBorder(new BevelBorder(BevelBorder.LOWERED));
        getContentPane().add(scrollpane);
        Data.setIntercellSpacing(new Dimension(1,1));
        pack();
        
        
    }
    /**Initialize components for tables generated by a PermanentResultSet */
    private void initComponentsForSavedTable()
    {
    	Data = new javax.swing.JTable();
		Data.setModel(getModelForSavedTable());
        Data.setGridColor(Color.BLUE);
        Data.doLayout();
        Data.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
        JScrollPane scrollpane = new JScrollPane(Data);
        scrollpane.setBorder(new BevelBorder(BevelBorder.LOWERED));
        getContentPane().add(scrollpane);
        Data.setIntercellSpacing(new Dimension(1,1));
        pack();
        
    }
    /**Finds metadata */
    private void querySet(ResultSet rs) {
            
           //Find the number of rows
            
            try
            {
            rs.beforeFirst();
            rs.last();
            recordCount = rs.getRow();
            rs.beforeFirst();
            }
            catch (SQLException sqe)
            {
            	JOptionPane.showMessageDialog(null,"Error in obtaining relation data!","Info",0);																											
            	sqe.printStackTrace();
            }
        } 
	/**Get model for table generated by a ResultSet */
	public TableModel getModel() {
  
		querySet(rs);
        
        return new AbstractTableModel() {
            				public int getRowCount() {
                			return recordCount;
            										 }
            
            					public int getColumnCount() {
                				
                				 int number_of_columns=0;
                				 try 
                				 {
                				 //rs.beforeFirst();
                				 number_of_columns=(rs.getMetaData()).getColumnCount();
            					 }
            					 catch (SQLException sqle)
            					 {
            					 JOptionPane.showMessageDialog(null,"Error in retriving metadata "  ,"Info",0);
            					 sqle.printStackTrace();
            					 }
            					 return number_of_columns;
            												}
            					
            					public String getColumnName(int column) 
            					{
            					String out=null;
            					
            					try{
            					//rs.beforeFirst();
            					out=((rs.getMetaData()).getColumnName(column+1));
            					}
            					catch (SQLException sqle)
            					{
            						JOptionPane.showMessageDialog(null,"Error in retriving metadata ","Info",0);																											
            						sqle.printStackTrace();
            					}
            					return out;
            					}
           						
           						
           						
           						 public Object getValueAt( int row, int column )
            					{
            						try {
                    					//rs.beforeFirst();
							
										rs.absolute( row + 1 );
                    					
                    					return rs.getString( column + 1 );
                						} 
           							     catch( SQLException ex ) 
                						{
                    					JOptionPane.showMessageDialog(null,"Error in retriving metadata","Info",0);	
                						ex.printStackTrace();
                					
                						}
                						return "";
            					}
        
    									};
    									
    }
  /**Get model for table generated by a PermanentResultSet */
	public TableModel getModelForSavedTable()
	{
		//Paste the vector in a correct fashion
		Vector tmp = new Vector();
		int i=currentSavedDoc.size();
		for (int j=0;j<i;j++)
		tmp.addAll((Vector)currentSavedDoc.get(j));
		final Vector temp=tmp;
		
		
	return new AbstractTableModel() {
            				public int getRowCount() {
                			return temp.size();
            											
            										}
            
            					public int getColumnCount() {
                				
                				 return columnNames.size();
            												}
            					
            					public String getColumnName(int column) 
            					{
            						return (String)columnNames.get(column) ;
            					}
           						
           						
           						
           						 public Object getValueAt( int row, int column )
            					{
            						return (String)((Vector)temp.get(row)).get(column);	
            						
            							
            						
            					}
        
    								};	
		
	}	
}
	