/* This file is part of MySQLConnectus by Sergio Decherchi

Copyright (C) 2004 Sergio Decherchi

This program is free software; you can redistribute it 
and/or modify it under the terms of the GNU General Public License 
as published by the Free Software Foundation; either version 2 of 
the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, 
but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
GNU General Public License for more details (gpl.txt).
You should have received a copy of the GNU General Public License 
along with this program; if not, write to the Free Software Foundation, 
Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA */

import java.util.regex.Pattern;
import java.io.*;
import java.util.*;
import java.net.*;
import java.sql.*;

/** This class is used to reorder data for printing or streaming */
public class OrderedData
{
	private		double		nt;
	public		int			numberOfTuples;
	public		int			numPages;	
	private		Vector		temp; 		
	public		Vector		page; 		
	public		Vector		doc;	
	private		String		tmp;
	
	/**Default constructor */
	OrderedData()
	{
	numberOfTuples	=	0;
	numPages		=	0;
	temp			=	new	Vector();
	page 			=	new	Vector();
	doc				=	new	Vector();
	}
    
/** Reorder method for ResultSet */
public int reorderForPrintingOrStreaming(ResultSet rs,int linesForPage,int numberOfColumns)
    {
    
    numberOfTuples	=	0;
    numPages		=	0;
    temp			=	new	Vector();
    page			=	new	Vector();
    doc				=	new	Vector();
    
    try
    {
   
    rs.beforeFirst();
    
    //long time=System.currentTimeMillis();
    
    //Here two ways for obtaining the same thing. the second is faster
    
    //1st way
    /*while(rs.next())
    	nt++;*/
    
    //2nd way
    rs.last();
    nt=new Double(rs.getRow()).doubleValue();
    rs.beforeFirst();
    
    //long time2=System.currentTimeMillis();
    //System.out.println( (time2-time)+"#"+nt);
            
    //System.out.println(numberOfTuples);
    //System.out.println((numberOfTuples/65));
    
    numPages=(new Double(Math.ceil(( nt/linesForPage)))).intValue();
    
    numberOfTuples=(new Double(nt)).intValue();
    
    doc  = new Vector(numPages);
    
    //System.out.println(numPages);
    
    rs.beforeFirst();
    
    
    for(int k=0;k<numPages;k++)
    {
    int n=0;
    	//System.out.println("OK");
    	//Don't change the order of conditions! 
    	while(n<linesForPage && rs.next())
    	{
    		for(int l=1;l<=numberOfColumns;l++)
    		{
    		//This control avoids NullPointer exeception due null values in relations
    		if ((tmp=rs.getString(l))!=null)
    		temp.add(tmp);	
    		else
    		temp.add("");
    		
    		//System.out.println(tmp);
    		
    		}
    		page.add(temp);
			temp=new Vector(0);   
    	n++;
    	}
    
    doc.add(page);	
    page=new Vector(0);
    }
    }
    catch(SQLException sqle2)
    {
    	return numPages;
    	
    }
    return numPages;
    }

/** Reorder method for Query/Modification text */
public int reorderForPrintingOrStreaming(String text,int linesForPage)

{

    
// This brainstorming tecnique is necessary for a correct printing, because
// the '\n' escape character is not recognised by drawString() method necessary
// for printing.
// First is necessary to "compile " a pattern.
// Compile means that "\n" will be set as a regular expression.

  			Pattern p = Pattern.compile("\n");

// The string is splitted accordingly the presetted regular expression
// in this case "\n"
// NOTE: A StringTokenizer is an object where the compiled pattern for 
// splitting is a backspace.  			

   			String strvec[]=p.split(text);         

//Reset variables.This is neccessary because we only have one current instance
//of orderedData class

int i=0;
numPages=0;
doc	=new Vector();
page=new Vector();
numberOfTuples=0;
nt=0;

try
{
while (true)
{
String fix=strvec[i];
nt++; //Instead would have to be "numberOfLines"
i++;
} 

}
catch(ArrayIndexOutOfBoundsException aioobe)
{
//No action needed .This catch is used only for stopping counting 
//at the right point
}

numberOfTuples=(new Double(nt)).intValue();
numPages=(new Double(Math.ceil(( nt/linesForPage)))).intValue();
    

//System.out.println(nt+" "+numPages);    

doc  = new Vector(numPages);
int l=0;
    
 try
 {
 for(i=0;i<numPages;i++)
    {
    int n=0;
    	while(n<linesForPage )
    	{
    	page.add(strvec[l]);	
    	//System.out.println(strvec[l]);
    	n++;
    	l++;
    	}
    
    doc.add(page);	
   // System.out.println( ((Vector)(doc.get(0))).get(0));
    page=new Vector();
    
    }

 }
 catch (ArrayIndexOutOfBoundsException aioobe)
 {
 //No action needed now the strvec[] is at its last element
 //System.out.println( ((Vector)(doc.get(0))).get(0));
 doc.add(page);	
 return numPages;
 }
 doc.add(page);	
 return numPages;
}    


}
	