/* This file is part of MySQLConnectus by Sergio Decherchi

Copyright (C) 2004 Sergio Decherchi

This program is free software; you can redistribute it 
and/or modify it under the terms of the GNU General Public License 
as published by the Free Software Foundation; either version 2 of 
the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, 
but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
GNU General Public License for more details (gpl.txt).
You should have received a copy of the GNU General Public License 
along with this program; if not, write to the Free Software Foundation, 
Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA */

import javax.swing.*;
import java.io.*;
import java.util.*;
import java.sql.*;

/**This class rapresents a ResultSet that can be saved using Serializable interface */

public class PermanentResultSet implements Serializable  
{

protected	Vector doc,columnNames;
private		OrderedData od; 
private		ResultSet rs;
private		ObjectOutputStream oos;
private		ObjectInputStream ois;
private		String fileName;
public		int cn;
public		int tn;
private		boolean isSaved=false;

/**Constructor  for output streaming ,starting by a ResultSet */
	PermanentResultSet(ResultSet rs1,java.io.ObjectOutputStream oos) throws IOException
	{
		
		rs=rs1;
		this.oos=oos;
		
		try
		{
		cn=((rs.getMetaData()).getColumnCount());
		write();
		tn=od.numberOfTuples;
		
		}
		catch (SQLException sqle)
		{
		JOptionPane.showMessageDialog(null,"Error in table writing!","Info",0);																											
		sqle.printStackTrace();
		}
		
	}
/**Constructor used only for initializing an outputstream */	
	PermanentResultSet(String fileName,ObjectInputStream ois)
	{
		this.fileName=fileName;
		this.ois=ois;
		read();
	}
	
/**Constructor used for output streaming ,starting by a Vector that contains data */	
	PermanentResultSet(ObjectOutputStream oos,Vector savedDoc,Vector columnNames,int cn,int tn)
	{
		doc=savedDoc;
		this.columnNames=columnNames;
		this.oos=oos;
		this.cn=cn;
		this.tn=tn;
		isSaved=true;
		try
		{
		writeObject(oos);
		}
		catch(IOException ioe)
		{
		JOptionPane.showMessageDialog(null,"Error in table writing!","Info",0);																											
		}
		
		
	} 
 
 /**Method used to write ResultSet */
 public void write()
 {
 try
		{
		
		rs.beforeFirst();
		od = new OrderedData();
		od.reorderForPrintingOrStreaming(rs,65,cn);	
		doc=od.doc;
		columnNames=new Vector();
		int column=0;
		rs.beforeFirst();
		
		while (column<cn)
		{
			
			columnNames.add(((rs.getMetaData()).getColumnName(column+1)));
			column++;
			
		}
		
		rs.beforeFirst();
		
		writeObject(oos);
		}
		catch (SQLException sqle2)
		{
		JOptionPane.showMessageDialog(null,"Error in table writing!","Info",0);																											
		sqle2.printStackTrace();
		}
		catch (IOException ioe )
		{
		JOptionPane.showMessageDialog(null,"Error in table writing!","Info",0);																											
		ioe.printStackTrace();
		}
		
 }	
 
 /**Method used to read stored data */
 public void read()
 {
 	try
 	{
 	readObject(ois);
 	}
 	catch (Exception ioe)
 	{
 		JOptionPane.showMessageDialog(null,"Table reading failed!","Info",0);																											
 		ioe.printStackTrace();
 		return ;
 	}
 	
 }
 /**Serializable interface implementation */
 private void writeObject(java.io.ObjectOutputStream out) throws IOException
 {
 
	if (!isSaved)
	{
	try
	{
	
	rs.beforeFirst();
	//Number of columns
	out.writeInt(cn);
	//Number of tuples
	out.writeInt(tn);
	
	}
	catch (SQLException sqle)
	{
	JOptionPane.showMessageDialog(null,"Table saving failed","Info",0);																											
	return;
	}
	
	}
	else
	{
	out.writeInt(cn);
	out.writeInt(tn);
	}
	
	out.writeObject(doc);
	out.writeObject(columnNames);
	out.close();
 	}
 /**Serializable interface implementation */
 private void readObject(java.io.ObjectInputStream in) throws IOException, ClassNotFoundException
 {
 	
	cn=in.readInt();
	tn=in.readInt();
	doc=(Vector)in.readObject();
	columnNames=(Vector)in.readObject();
	in.close();

 
 }
	

}
	